MEMORY 
{
	sram0	: ORIGIN = 0x00200000, LENGTH = 1K
	sdram	: ORIGIN = 0x20000000, LENGTH = 16M
}

/* Stack end at the end of SDRAM */
__stack_end__ = 0x20000000 + 16M - 4;

SECTIONS 
{
	. = 0;

	startup :
	{
		*(.startup)
	} >sdram

	prog : 
	{
		*(.text)
		*(.rodata)
		*(.rodata*)
		*(.glue_7)
		*(.glue_7t)
	} >sdram

	__end_of_prog__ = .;

	vectors : 
	{ 
		__vect_beg__ = .;
		__vect_beg_src__ = __end_of_prog__;
		*(.vectors)
		__vect_end__ = .;
	} >sram0 AT>sdram

	. = __end_of_prog__ + SIZEOF(vectors);
	__end_of_vect__ = .;
	
	.data : 
	{
		__data_beg__ = .;
		__data_beg_src__ = __end_of_vect__;
		*(.data)
		__data_end__ = .;
	} >sdram

	.bss : 
	{
		__bss_beg__ = .;
		*(.bss)
	} >sdram

	/* Align here to ensure that the .bss section occupies space up to
	_end.  Align after .bss to ensure correct alignment even if the
	.bss section disappears because there are no input sections.  */
	. = ALIGN(32 / 8);
}
	. = ALIGN(32 / 8);
	_end = .;
	_bss_end__ = . ; __bss_end__ = . ; __end__ = . ;
	PROVIDE (end = .);


