/*
     FreeRTOS.org V5.0.2 - Copyright (C) 2003-2008 Richard Barry.

	This file is part of the FreeRTOS.org distribution.

	FreeRTOS.org is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	FreeRTOS.org is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with FreeRTOS.org; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	A special exception to the GPL can be applied should you wish to distribute
	a combined work that includes FreeRTOS.org, without being obliged to provide
	the source code for any proprietary components.  See the licensing section
	of http://www.FreeRTOS.org for full details of how and when the exception
	can be applied.
    
    ***********************************************************************
    FreeRTOS port  for IAR M16C
    2008, Felix Daners Engineering. f.daners@swissworld.com
    ***********************************************************************
*/

#ifndef FREERTOS_CONFIG_H
#define FREERTOS_CONFIG_H

/* IO definitions for the chosen device. */
#ifndef __IAR_SYSTEMS_ASM__
 #include <iom16c62p.h>
 #include <intrinsics.h>
#endif

/*-----------------------------------------------------------
 * Application specific definitions.
 *
 * These definitions should be adjusted for your particular hardware and
 * application requirements.
 *
 * THESE PARAMETERS ARE DESCRIBED WITHIN THE 'CONFIGURATION' SECTION OF THE
 * FreeRTOS API DOCUMENTATION AVAILABLE ON THE FreeRTOS.org WEB SITE.
 *----------------------------------------------------------*/

#define configUSE_PREEMPTION            ( 1 )
#define configUSE_IDLE_HOOK             ( 0 )
#define configUSE_TICK_HOOK             ( 0 )
#define configCPU_CLOCK_HZ              ( ( unsigned portLONG ) 12000000UL )
#define configTICK_RATE_HZ              ( ( portTickType ) 1000 )
#define configMAX_PRIORITIES            ( ( unsigned portBASE_TYPE ) 4 )
#define configMINIMAL_STACK_SIZE        ( ( unsigned portSHORT ) 40 )
#define configTOTAL_HEAP_SIZE	        ( ( size_t ) ( 1024 ) )
#define configMAX_TASK_NAME_LEN	        ( 8 )
#define configUSE_TRACE_FACILITY        ( 0 )
#define configUSE_16_BIT_TICKS          ( 1 )
#define configIDLE_SHOULD_YIELD	        ( 1 )

#define configUSE_INTRINSIC_MEMCPY_MEMSET_MEMMOVE (1)
#define configADD_T_TYPE_SUPPORT        ( 1 ) /* define uint8_t etc. */

#define configCHECK_FOR_STACK_OVERFLOW  ( 1 )

#define configKERNEL_INTERRUPT_PRIORITY       0
#define configMAX_SYSCALL_INTERRUPT_PRIORITY  4

/* Co-routine definitions. */
#define configUSE_CO_ROUTINES           ( 0 )
#define configMAX_CO_ROUTINE_PRIORITIES ( 2 )

/* Set the following definitions to 1 to include the API function, or zero
to exclude the API function. */

#define INCLUDE_vTaskPrioritySet        ( 1 )
#define INCLUDE_uxTaskPriorityGet       ( 1 )
#define INCLUDE_vTaskDelete             ( 0 )
#define INCLUDE_vTaskCleanUpResources   ( 0 )
#define INCLUDE_vTaskSuspend            ( 1 )
#define INCLUDE_vTaskDelayUntil	        ( 1 )
#define INCLUDE_vTaskDelay              ( 1 )
#define INCLUDE_vTaskSuspend            ( 1 )
#define INCLUDE_xTaskResumeFromISR      ( 1 )



#if defined(config_T_TYPE_SUPPORT) && !defined(__IAR_SYSTEMS_ASM__)
typedef unsigned long           uint32_t;
typedef signed long             int32_t;
typedef unsigned short          uint16_t;
typedef signed short            int16_t;
typedef unsigned char           uint8_t;
typedef signed char             int8_t;
#endif



#define USER_ISR_VECTOR_28 timerB2_isr
#define USER_ISR_VECTOR_27 timerB1_isr



#endif /* FREERTOS_CONFIG_H */
